require_dependency "skirental_payment/application_controller"

module SkirentalPayment
    class PaymentsController < AuthenticatedController
        def index
            payments = Payment.all

            render json: payments
        end

        def show
            payment = Payment.where(payment_reference: payment_params[:payment_reference]).first

            render json: payment
        end

        private

        # Will be called by derived classes before saving the payment
        def confirm_payment(payment_context, is_reservation = false)
            puts "confirming the booking now…"
            api_booking = SkirentalApi::Client.confirm_booking(payment_context.booking, is_reservation, payment_context)
            voucher_code = api_booking[:code]
            payment_context.voucher_code = voucher_code if voucher_code.present?
        end

        def payment_params
            params.permit(:payment_reference)
        end
    end
end
