module SkirentalPayment
    class ReservationsController < PaymentsController

        def create
            booking = SkirentalFrontendApi::Booking.where(shop_id: reservation_params[:shop_id], session_id: reservation_params[:session_id]).first
            fail if booking.nil?

            payment_context = SkirentalPayment::Payment.new(booking_id: booking.id, is_reserved: true)

            confirm_payment(payment_context, true)
            if payment_context.save
                render json: { error: "", voucher: payment_context.voucher_code }, status: :created
            else
                render json: { error: payment_context.errors.full_messages }, status: :internal_server_error
            end
        end

        private

        def reservation_params
            params.permit(:shop_id, :session_id)
        end
    end
end
